package be.iminds.ilabt.jfed.experimenter_gui.controller.controller.action;

import be.iminds.ilabt.jfed.experimenter_gui.controller.model.ControllerModel;
import be.iminds.ilabt.jfed.experimenter_gui.controller.view.IControllerComponent;
import be.iminds.ilabt.jfed.experimenter_gui.controller.view.UpdateEvent;
import be.iminds.ilabt.jfed.rspec.model.controller.ExperimentCommand;

/**
 * @author Cedric
 */
public class DeleteCommandAction implements IAction {
    private ExperimentCommand command;

    public DeleteCommandAction(ExperimentCommand command) {
        this.command = command;
    }

    @Override
    public boolean execute(ControllerModel model, IControllerComponent view) {
        //can't remove a command that's already started execution
        if (command.isStarted())
            return false;

        model.deleteCommand(command);
        view.update(UpdateEvent.DELETE_COMMAND, command);
        return true;
    }

    @Override
    public boolean undo(ControllerModel model, IControllerComponent view) {
        //Can't add if the starting time is already in the past
        if (model.getElapsedTime() > command.getStartingTime().toMillis())
            return false;

        model.addCommand(command);
        view.update(UpdateEvent.ADD_COMMAND, command);
        return true;
    }
}
