package be.iminds.ilabt.jfed.highlevel.jobs;

import be.iminds.ilabt.jfed.experiment.Experiment;
import be.iminds.ilabt.jfed.highlevel.controller.Task;
import be.iminds.ilabt.jfed.highlevel.controller.TaskExecution;
import be.iminds.ilabt.jfed.highlevel.controller.TaskExecutionFinishedCallback;
import javafx.beans.property.ReadOnlyObjectProperty;
import javafx.beans.property.ReadOnlyStringProperty;

import java.util.concurrent.Callable;

/**
 * User: twalcari
 * Date: 7/13/2015
 * Time: 16:28
 */
public interface Job<V> extends Callable<V> {

    Experiment getExperiment();
    String getName();

    <T extends Task> TaskExecution<T> submitTask(T t, TaskExecutionFinishedCallback... callbacks);

    <T extends Task>TaskExecution<T> submitTaskAndWait(T task) throws InterruptedException;

    State getState();
    String getMessage();

    ReadOnlyObjectProperty<State> stateProperty();
    ReadOnlyStringProperty messageProperty();


}
