package be.iminds.ilabt.jfed.highlevel.jobs.states;

import be.iminds.ilabt.jfed.experiment.Experiment;
import be.iminds.ilabt.jfed.experiment.tasks.ExperimentTaskStatus;
import be.iminds.ilabt.jfed.highlevel.jobs.Job;
import be.iminds.ilabt.jfed.highlevel.jobs.State;
import be.iminds.ilabt.jfed.highlevel.model.SfaModel;
import be.iminds.ilabt.jfed.highlevel.model.UserSpecHelper;
import be.iminds.ilabt.jfed.lowlevel.GeniUserProvider;
import be.iminds.ilabt.jfed.lowlevel.api.user_spec.UserSpec;

import javax.annotation.Nonnull;
import java.util.List;

/**
 * User: twalcari
 * Date: 12/4/2015
 * Time: 14:42
 */
public class CreateUserSpecListState extends State {
    private List<UserSpec> userSpecs = null;

    private final Experiment experiment;
    private final GeniUserProvider geniUserProvider;
    private final SfaModel sfaModel;

    protected CreateUserSpecListState(Experiment experiment, GeniUserProvider geniUserProvider, SfaModel sfaModel) {
        super("Gathering experiment members info");
        this.experiment = experiment;
        this.geniUserProvider = geniUserProvider;
        this.sfaModel = sfaModel;
    }

    @Nonnull
    @Override
    public ExperimentTaskStatus executeState(Job<?> job) throws InterruptedException {
        assert experiment.getSlice().getRequestRspec() != null;
        userSpecs = UserSpecHelper.getMergedUserSpecs(geniUserProvider, sfaModel,
                experiment.getSlice().getRequestRspec().getModelRspec());

        if (experiment.isIncludeProjectMemberSshKeys())
            userSpecs = UserSpecHelper.mergeUserSpecs(userSpecs,
                    UserSpecHelper.getSliceMemberUserSpecs(experiment.getSlice().getUrn(), sfaModel));

        return ExperimentTaskStatus.SUCCESS;
    }

    public List<UserSpec> getUserSpecs() {
        return userSpecs;
    }
}
